<?php

require_once(dirname(__FILE__).'/const.php');

define('DiscloseSecret_ACTION_MIGRATE_POSTRESTRICTIONS', 'migrate_post_restrictions');
define('DiscloseSecret_CONFIG_FORM_ID_POSTRESTRICTIONS', 'post_restrictions_migrate');

// ----------------------------------------------------------------------------
// the DiscloseSecret_MigratorPostRestrictions class migrates the Post
// Restrictions plugin to Disclose-Secret
// ----------------------------------------------------------------------------

class DiscloseSecret_MigratorPostRestrictions
{
	var $m_status;

	function DiscloseSecret_MigratorPostRestrictions()
	{
		$this->m_status = DiscloseSecret_MIGRATION_NOT_NEEDED;
	}

	function get_name()
	{
		return 'MigratorPostRestrictions';
	}

	function migrate($interactive = true)
	{
		$this->m_status = $this->migrate_plugin($interactive);
		return $this->m_status;
	}

	function migrate_plugin($interactive = true)
	{
		global $wpdb;

		if ($interactive)
			$do_migration = isset($_POST[DiscloseSecret_ACTION_MIGRATE_POSTRESTRICTIONS]);
		else
			$do_migration = true;

		// find out whether plugin is installed
		$postrestrictions_installed = false;
		$query = "
			SELECT COUNT(*)
			FROM {$wpdb->postmeta}
			WHERE meta_key = '". DiscloseSecret_POSTRESTRICTIONS_META. "'
		";
		if ($wpdb->get_var($query) > 0)
			$postrestrictions_installed = true;

		if (!$postrestrictions_installed)
			return DiscloseSecret_MIGRATION_NOT_NEEDED;
		if (!$do_migration)
			return DiscloseSecret_MIGRATION_SKIPPED;
		if ($interactive)
			check_admin_referer(DiscloseSecret_ACTION_MIGRATE_POSTRESTRICTIONS);

		$query = "
			UPDATE {$wpdb->postmeta}
			SET meta_key = '". DiscloseSecret_META_CAP. "'
			WHERE meta_key = '". DiscloseSecret_POSTRESTRICTIONS_META. "'
		";
		$wpdb->query($query);

		// option are migrated to new plugin name
		$option = get_option(DiscloseSecret_POSTRESTRICTIONS_PLUGIN_ID);
		update_option(DiscloseSecret_PLUGIN_ID, $option);
		delete_option(DiscloseSecret_POSTRESTRICTIONS_PLUGIN_ID);

		return DiscloseSecret_MIGRATION_DONE;
	}

	function print_form()
	{
		// no form for non-interacitve migrator
	}
}

?>